Unit main;

Interface

Uses
 Windows,
 Messages,
 SysUtils,
 Classes,
 Controls,
 Forms,
 Dialogs,
 SPparse,
 Menus,
 StdCtrls,
 Buttons,
 Graphics,
 ExtCtrls;

Type
 TForm1 = Class(TForm)
  EditCharacter: TEdit;
  Label1: TLabel;
  EditSearchText: TEdit;
  Label2: TLabel;
  LabelFound: TLabel;
  chkIsSpaceAfterCharacter: TCheckBox;
  ListBox: TListBox;
  MainMenu: TMainMenu;
  MnuParse: TMenuItem;
  MnuFile: TMenuItem;
  MnuFileExit: TMenuItem;
  chkSort: TCheckBox;
  SpeedButton1: TSpeedButton;
  SPparse: TSPparse;
  Image1: TImage;
  Procedure MnuFileExitClick(Sender: TObject);
  Procedure MnuParseClick(Sender: TObject);
  Procedure SPparseWordFound(Sender: TObject);
  Procedure ListBoxDrawItem(Control: TWinControl;
   Index: Integer;
   Rect: TRect;
   State: TOwnerDrawState);
  Procedure FormShow(Sender: TObject);
 Private
  { Private-Deklarationen }
 Public
  { Public-Deklarationen }
 End;
 
Var
 Form1              : TForm1;
 
Implementation

{$R *.DFM}

Procedure TForm1.MnuFileExitClick(Sender: TObject);
Begin
 Close;
End;

Procedure TForm1.MnuParseClick(Sender: TObject);
Var
 i                  : Word;
Begin
 LabelFound.Caption := '';
 ListBox.Clear;
 ListBox.Sorted := chkSort.Checked;
 SPparse.SearchText := EditSearchText.Text;
 SPparse.Character := EditCharacter.Text;
 SPparse.IsSpaceAfterCharacter := chkIsSpaceAfterCharacter.Checked;
 If Not SPparse.Execute Then
  MessageDlg('SPparse couldn''t be executed', mtError, [mbOK], 0)
 Else
  Begin
   For i := 0 To SPparse.Found - 1 Do
    Begin
     ListBox.Items.Add(SPparse.Words[i]);
    End;
   { It would be possible to assign the Words like this, }
   { ListBox.Items := SPparse.Words; }
   { but the ListBox would have one empty Item at least }
  End;
End;

Procedure TForm1.SPparseWordFound(Sender: TObject);
Begin
 LabelFound.Caption := IntToStr(SPparse.Found) + '  Word(s) found !';
End;

Procedure TForm1.ListBoxDrawItem(Control: TWinControl;
 Index: Integer;
 Rect: TRect;
 State: TOwnerDrawState);
Var
 Offset             : Word;
 Bitmap             : TBitmap;
Begin
 Bitmap := TBitmap.Create;
 Bitmap.Assign(Image1.Picture);
 Offset := Bitmap.Width * 3;
 With (Control As TListBox).Canvas Do
  { Draw on the Canvas of the Dialogelement, not on the Form! }
  Begin
   If Index Mod 2 = 0 Then
    Brush.Color := clScrollBar
   Else
    Brush.Color := clActiveCaption;
   FillRect(Rect);
   If Bitmap <> Nil Then
    Begin
     BrushCopy(Bounds(Rect.Left + 2, Rect.Top, Bitmap.Width, Bitmap.Height),
      Bitmap,
      Bounds(0, 0, Bitmap.Width, Bitmap.Height), clWhite); { Draw Bitmap }
    End;
   TextOut(Rect.Left + Offset, Rect.Top, ListBox.Items[Index]);
  End;
End;

Procedure TForm1.FormShow(Sender: TObject);
Begin
 Caption := Application.Title;
 Image1.Visible := False;
 With ListBox Do
  Begin
   Color := Form1.Color;
   Font.Color := clBtnText;
   IntegralHeight := True;
   Style := lbOwnerDrawVariable;
   ItemHeight := Image1.Height;
  End;
End;

End.

